$L=$ARGV[0];
$FILE=$ARGV[1];

use File::Basename;
$L =~ s,/*$,,;
$lang =  basename($L);
$lang =~ s/translations_//;
$file =  basename($FILE);

my %origs;
my %trans;

opendir(DOMS, "$L/en_US/LC_MESSAGES/") || die "opendir $L";
@mos = grep { /\.mo$/ } readdir(DOMS);
close DOMS;

sub flush_translation()
  {
      foreach $tag ('Name', 'Comment', 'GenericName') 
	{
	    next if (!defined $trans{$tag});
	    #print "#SUSE-Addition\n";
	    print "$tag\[$lang\]=$trans{$tag}\n";
	    print STDERR "adding '$tag\[$lang\]=$trans{$tag}' to $file\n";
	    delete $trans{$tag};
	}
  }

my $flagged = 0;
my $group = '';

open(FILE, "$FILE");
while ( <FILE> )
  {
      $flagged = 1 if ($_ =~ /X-SuSE-translate=true/ && $group eq '[Desktop Entry]');

      # new group
      if ($_ =~ /^\[/ )
	{
	    flush_translation();
	    my $line = $_;
	    chomp $line;
            if (!$flagged && $group eq '[Desktop Entry]') {
		print "X-SuSE-translate=true\n";
		$flagged = 1;
	    }
	    $group = $line;
	    %origs = ();
	    %trans = ();
	    print $_;
	    next;
	}

      foreach $tag ('Name', 'Comment', 'GenericName')
	{
	    if ($_ =~ m/^$tag=/ ) {
		$text = $_;
		chomp($text);
		$text =~ s/$tag=//;
		$origs{$tag} = $text;
		$text = "$tag($file): $text";
		
		foreach $domain (@mos)
		  {
		      $domain=basename($domain, ".mo");
		      $ENV{"TEXTDOMAINDIR"} = $L;
		      $ENV{"LC_ALL"} = "en_US.UTF-8";
		      open(GETTEXT, "-|", "gettext", "-d", "$domain", "$text");
		      $transe=<GETTEXT>;
		      close(GETTEXT);
		      next if ($transe eq $text);
		      next if ($transe eq $origs{$tag});
		      $trans{$tag} = $transe;
		  }
		next;
	    }
		
	    if ( $_ =~ /^$tag\[$lang\]/)
	      {
		  if (! defined $origs{$tag}) {
		      print STDERR "ERROR: $tag is translated before original. Not supported - patch desktop file $FILE\n";
		      exit(1);
		  }
		  $text = $_;
		  chomp($text);
		  $text =~ s/^$tag\[$lang\]=//;
		  # no reason to act
		  $ourtrans = $origs{$tag};
		  $ourtrans = $trans{$tag} if (defined $trans{$tag});
		
		  if ($text eq $ourtrans)
		    {
			delete $trans{$tag};
			#print "# SUSE Copy\n";
			next;
		    }

		  print "#SUSE-Overwrite $_";
		  # if not defined, we prefer the orig
		  if (defined $trans{$tag})
		    {
			print STDERR "adding '$tag\[$lang\]=$ourtrans' to $file\n";
			$_ = "$tag\[$lang\]=$ourtrans\n";
			delete $trans{$tag};
		    } else {
			print STDERR "removing '$tag\[$lang\]=$text' from $file\n";
			$_ = '';
		    }
		  next;
	      }
	}
      print $_ if ($_);
  }

flush_translation();
if (!$flagged)  {
	print "X-SuSE-translate=true\n";
}

